#include <Wire.h>
#include "stDHT.h"

DHT sens(DHT11); // Указать датчик DHT11, DHT21 или DHT22. (несколько датчиков вписывать не нужно)
// Подключать можно только одинаковые датчики, то есть нельзя использовать одновременно DHT11 и DHT22

#include <DallasTemperature.h>
#include <OneWire.h>
#define ONE_WIRE_BUS 10
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);
 
unsigned long  mills_cur;
unsigned long  rotation=10000;
unsigned long  mills_prev=0;

float total;// искомая переменная киловатт часов!!!!!!!

/*
Код мониторинга электропотребления и трансляции
данных на сервер majordomo
Arduino IDE 0023

Подключение датчиков:
Тока - аналоговый вход A1
Напр.- аналоговый вход A0
Схема подключения дисплея J204A (4 ряда, 20символов):
* LCD RS пин к цифр. выходу 8
* LCD Enable пин к цифр. выходу 7
* LCD R/W к Общему
* LCD VO пин (пин 3) к ШИМ-выходу 9
* LCD D4 пин к цифр. выходу 6
* LCD D5 пин к цифр. выходу 5
* LCD D6 пин к цифр. выходу 3
* LCD D7 пин к цифр. выходу 2

* LCD VSS к Общему
* LCD VDD к +5V
* LCD A к +3,3 или +5V (подсветка)
* LCD K к Общему (подсветка)
*/
/*#include <Ethernet.h>//отсюда вниз
#include <SPI.h>


byte mac[] = { 0x00, 0x2A, 0xF6, 0x12, 0x69, 0xDU }; // MAC-адрес устройства
byte ip[] = { 192, 168, 1, 40 }; // ip-адрес устройства
byte server[] = { 192, 168, 1, 48 }; // IP компьютера на котором установлен сервер majordomo
byte gateway[] = { 192, 168, 1, 1 };
byte subnet[] = { 255, 255, 255, 0 };
char buf[80];
Client rclient(server, 80); // 80-порт

// Функция отправки HTTP-запроса на сервер
void sendHTTPRequest()
{
Serial.println(buf);
if (rclient.connect())
{
Serial.println("OK");
rclient.println(buf);
rclient.println("Host: 192.168.1.48"); // IP компьютера на котором установлен сервер majordomo
rclient.println();
delay(2000);
rclient.stop();
}

}
*/
//до сюда вверх
int numberOfSamples = 400;

//Установка датчиков тока и напряжения
int inPinV = 0;
int inPinI = 1;

//*************************************************************************


// Коэффициенты для калибровки выводимых значений
// Подбираются опытным путем сверяясь с эталонным прибором
double VCAL = 17.90; // для напряжения
double ICAL = 1.90; // для тока2.21
double PHASECAL = 2.3; // для мощности

//*************************************************************************

double V_RATIO = 50.5 / 1024 * VCAL;
double I_RATIO = (long double) 15.15 * 5 / 1024 * ICAL;

//Образцы переменных
int lastSampleV,lastSampleI,sampleV,sampleI;

//Переменные для фильтров
double lastFilteredV, lastFilteredI, filteredV, filteredI;
double filterTemp;

//Сюда сохраняем калибровочное значение фазы мгновенного напряжения
double shiftedV;

//Расчет переменной для мощности
double sqI,sqV,instP,sumI,sumV,sumP;

//Полезные значения переменных
double realPower,
apparentPower,
apparentPower1,
powerFactor,
Vrms,
Irms;

// подключаем библиотеку дисплея:

#include <LiquidCrystal_I2C.h>
// инициализация библиотеки с перечнем задействованных выводов
//LiquidCrystal lcd (8, 7, 6, 5, 3, 2);
LiquidCrystal_I2C lcd(0x27,20,4);
// подключаем библиотеку дисплея:
//#include <LiquidCrystal.h>

// инициализация библиотеки с перечнем задействованных выводов
//LiquidCrystal lcd (8, 7, 6, 5, 3, 2);

void setup (void)
{
  sensors.begin();
  Serial.begin(9600);
  pinMode(2, INPUT);//подключаем DHT пока не кончатся пины или память
  digitalWrite(2, HIGH);
  pinMode(3, INPUT);
  digitalWrite(3, HIGH);
  
//Ethernet.begin(mac, ip, gateway, subnet); // Инициализируем Ethernet Shield

// устанавливаем ШИМ выход (регулируем контрастность дисплея):
//pinMode (9, OUTPUT);
//analogWrite (9, 70);
// устанавливаем кол-во столбцов и строк:
lcd.begin (20, 4);
lcd.init();
lcd.backlight();
//lcd.setCursor(0, 0);
//lcd.print("   POWER  MONITOR");

}
void loop (void)
 {
   mills_cur=millis();
   sensors.requestTemperatures();
Serial.print("T0=");
Serial.println(sensors.getTempCByIndex(0));
delay(200);
Serial.print("T1=");
Serial.println(sensors.getTempCByIndex(1));
delay(200);
Serial.print("T2=");
Serial.println(sensors.getTempCByIndex(2));
  

if (mills_cur>mills_prev+rotation) {
  int t = sens.readTemperature(2); // чтение датчика на пине 2
  int h = sens.readHumidity(2);    // чтение датчика на пине 2
  delay(2000);
  
  int t2 = sens.readTemperature(3); // чтение датчика на пине 3
  int h2 = sens.readHumidity(3);    // чтение датчика на пине 3
  delay(2000);

  
  Serial.print("Hum: ");
  Serial.print(h);
  Serial.print(" %");
  Serial.print("Temp: ");
  Serial.print(t);
  Serial.println(" C ");
  Serial.print("Hum2: ");
  Serial.print(h2);
  Serial.print(" %");
  Serial.print("Temp2: ");
  Serial.print(t2);
  Serial.println(" C "); 

 

//Serial.println(temp);
for (int n=0; n<numberOfSamples; n++) // цикл крутится 3000 раз
{

//Используется для удаления смещения 2,5в
lastSampleV=sampleV;
lastSampleI=sampleI;

//Читаем с пинов текущее значение U и I
sampleV = analogRead(inPinV);
sampleI = analogRead(inPinI);

// Используется для удаления смещения 2,5в
lastFilteredV = filteredV;
lastFilteredI = filteredI;

//Цифровой фильтр для удаления постоянного смещения 2,5 в

filteredV = 0.996*(lastFilteredV+sampleV-lastSampleV);
filteredI = 0.996*(lastFilteredI+sampleI-lastSampleI);

//Тут калибруем фазу
shiftedV = lastFilteredV + PHASECAL * (filteredV - lastFilteredV);

//Среднеквадратический метод расчета напряжения
//1) square voltage values
sqV= filteredV * filteredV;
//2) Суммируем
sumV += sqV;

// Среднеквадратический метод расчета тока
//1) square current values
sqI = filteredI * filteredI;
//2) Суммируем
sumI += sqI;

//Мгновенная мощность
instP = shiftedV * filteredI;
//Суммируем
sumP +=instP;
}

//Расчет корня из среднего напряжения и тока (rms)
Vrms = V_RATIO*sqrt(sumV / numberOfSamples);
Irms = I_RATIO*sqrt(sumI / numberOfSamples);

//Расчет величины мощности
//realPower = V_RATIO*I_RATIO*sumP / numberOfSamples;
apparentPower = (Vrms * Irms)/1000; // значение в Киловатах
apparentPower1 = (Vrms * Irms); // значение в Ваттах
powerFactor = realPower / apparentPower;

//Сброс накопленных значений
sumV = 0;
sumI = 0;
sumP = 0;

total+=apparentPower/360;//360 10 секундных отсчетов в часе

// устанавливаем курсор в 1-ом столбце, 1 строка (начинается с 0):
lcd.setCursor (1, 1);
lcd.print ("U=");
lcd.setCursor (3, 1);
lcd.print (Vrms);
lcd.setCursor (10, 1);
lcd.print ("I=");
lcd.setCursor (12, 1);
lcd.print (Irms);
//lcd.print(sampleI);
lcd.setCursor (0, 2);
lcd.print ("P=");
lcd.setCursor (2, 2);
lcd.print(apparentPower);
lcd.setCursor (6, 2);
lcd.print ("kW");
lcd.setCursor (9, 2);
lcd.print ("kWt/h");
lcd.setCursor (15, 2);
lcd.print(total);
lcd.setCursor (0, 3);
lcd.print ("Hum:");
lcd.setCursor (4, 3);
lcd.print (h);
lcd.setCursor (7, 3);
lcd.print ("%");
lcd.setCursor (9, 3);
lcd.print ("Temp:");

lcd.setCursor (14, 3);
lcd.print (t);
lcd.setCursor (17, 3);
lcd.print ("C*");
lcd.setCursor (0, 0);
lcd.print (sensors.getTempCByIndex(0));
lcd.setCursor (7, 0);
lcd.print (sensors.getTempCByIndex(1));
lcd.setCursor (14, 0);
lcd.print (sensors.getTempCByIndex(2));
/*

// отправляем значения на сервер majordomo

//значение напряжения
sprintf(buf, "GET /objects/?object=sensorVolt&op=m&m=eleChanged&t=%0d.%d HTTP/1.0", (int)Vrms, abs(Vrms));
//sprintf(buf, "GET /objects/?object=sensorVolt&op=m&m=eleChanged&t=%d HTTP/1.0", Vrms);
sendHTTPRequest();

//значение тока
sprintf(buf, "GET /objects/?object=sensorAmper&op=m&m=eleChanged&t=%0d.%d HTTP/1.0", (int)Irms, abs(Irms));
sendHTTPRequest();

//значение мощности
sprintf(buf, "GET /objects/?object=sensorVatt&op=m&m=eleChanged&t=%0d.%d HTTP/1.0", (int)apparentPower1, abs(apparentPower1));
sendHTTPRequest();
//delay(3000);

*/
mills_prev=mills_cur;
}
}
